;========= SpellCheck v1.1 =========
;===================================
; A script that spell checks text in 
; Channels and query windows using a
; dictionary database and a refined
; version of the Soundex Algorithim
;-----------------------------------
; by: MaxP
; e-mail: asus69@hotmail.com
;====================================
on *:load:{ echo -a SpellCheck 1.1 loaded | echo -a  To check text in an editbox press Ctrl+F3 | echo -a  Check the Channel popup menu to switch Auto correction on/off }
menu menubar {
  Spell Checker
  ;  .Settings:{ dialog -m S.settings S.settings }
  ;  .-
  .Custom Dictionary:{ dialog -m S.CDict S.CDict }
  .Add 'Word List':{
    mkdir new
    var %f = $shortfn($sfile($mircdir,Select 'Word List' to load.,Load))
    if (!%f) { return }
    var %l = $lines(%f)
    var %nf = new\ $+ $nopath(%f)
    var %n2 = 1
    while (%n2 <= %l) {
      var %t = $read(%f,n,%n2)
      S.add %t
      S.pbar %n2 %l
      inc %n2
    }
    S.pbar -c
  }
  .-
  .Unload:{ unload -rs $script }
}

menu channel {
  Channel Spell Checker ( $+ $iif($r.set(settings,SCC),On,Off) $+ )
  .Switch $iif($r.set(settings,SCC),off,on) in Channels:{ w.set settings SCC $iif($r.set(settings,SCC),0,1) }
}

;menu query {
;  Query Spell Checker ( $+ $iif($r.set(settings,SCQ),On,Off) $+ )
;  .Switch $iif($r.setsettings,SCC),off,on) in Queries:{ w.set settings SCC $iif($r.set(settings,SCC),0,1) }
;}

;;---- Progress Bar ----
alias S.pbar {
  ;<line> <lines>
  if ($1 == -c) { window -c @S.prog | return }
  var %prm = $calc(100 / $2)
  var %n = $round($calc(%prm * $1 * 2))
  if (!$window(@S.prog)) { 
    window -apCd +d @S.prog 0 0 204 24
    drawline -n @S.prog 01 02 1 1 200 1 200 20 1 20 1 1 
  }
  drawrect -nf @S.prog 02 02 0 0 %n 20
  ;  drawfill -n @S.prog 02 02 1 1 
  drawdot @S.prog
}
;;-----------------------
alias -l r.set { if ($2 != $null) { return $readini -n $shortfn($scriptdir $+ SCset.ini) $1 $2 } }
alias -l w.set { if ($3 != $null) { writeini -n $shortfn($scriptdir $+ SCset.ini) $1 $2 $strip($3-,burc) } }

alias -l d.cd { if ($read($shortfn($scriptdir $+ Dictionary\custom.txt),wn,$1)) { write -dl [ $+ [ $readn ] ] $shortfn($scriptdir $+ Dictionary\custom.txt) } | else { if ($isid) { return 1 } } }
alias -l r.cdn { if ($read($shortfn($scriptdir $+ Dictionary\custom.txt),$1)) { return $ifmatch } }
alias -l w.cd { if ($1- !isalpha) { echo -a letters only please | return 1 } | if (!$read($shortfn($scriptdir $+ Dictionary\custom.txt),wn,$1)) { write $shortfn($scriptdir $+ Dictionary\custom.txt) $1 } | else { if ($isid) { return 1 } } }

alias cf3 {
  set %SC.txt $editbox($active)
  set %SC.edit 1
  set %SC.n 1
  S.check.1
}
on *:input:#:{
  if ((!$r.set(settings,SCC)) || ($left($1,1) == $chr(47))) { return }
  set %SC.chan $chan
  set %SC.txt $1-
  if ($right($1,1) !isalpha) { set %SC.n 2 }
  else { set %SC.n 1 }
  if ($halted) return
  S.check.1
  halt
  ;  haltdef
  ;  S.check.1
}
;on *:input:?:{ 
;  if ((!$r.set(settings,SCQ)) || ($left($1,1) == $chr(47))) { return }
;  set %SC.chan $active
;  set %SC.txt $1-
;  if ($right($1,1) !isalpha) { set %SC.n 2 }
;  else { set %SC.n 1 }
;  if ($halted) return
;  haltdef
;  S.check.1
;}

alias S.check.1 {
  :start
  if (%SC.n > $numtok(%SC.txt,32)) { if (%SC.edit) { editbox -a %SC.txt } | else { msg %SC.chan %SC.txt } | unset %SC.* | return }
  var %w = $gettok(%SC.txt,%SC.n,32)
  ;  var %cw = $strip($remove(%w,$chr(40),$chr(41),$chr(44),.,?,!,:,;,",'))
  var %cw = $strip(%w) | if ((%cw ison %SC.chan) || (%cw == %SC.chan)) { inc %SC.n | goto start } | if ($right(%w,1) !isalpha) { %cw = $left(%cw,-1) }
  if ((%cw ison %SC.chan) || (%cw == %SC.chan)) { inc %SC.n | goto start }
  if ($left(%cw,1) !isalpha) { %cw = $right(%cw,-1) } | %cw = $remove(%cw,')
  if ($remove(%cw,') isalpha) {
    set %SC.w %cw
    S.check.2 $ifmatch
  }
  else { inc %SC.n | goto start }
}

alias S.check.2 {
  unset %r | unset %mws
  var %c = $S.code(-s,$1)
  var %f = $scriptdir $+ Dictionary\Dictionary- $+ $left(%c,1) $+ .txt
  var %k = %c $+ $chr(61) $+ $1
  if ($read(%f,wn,%k,1)) { inc %SC.n | S.check.1 | return }
  ;;---- Checker ----
  dialog -m S.dialog S.dialog
  did -a S.dialog 11 $1

  var %n1 = $len($1)
  var %mw | var %n2 | var %mwt | var %p | var %mwt1 | var %mwt2 | var %n = 1 | var %rl | var %mws
  %k = %c $+ $chr(61) $+ * | %k = $eval(%k,1)
  while ($read(%f,wn,%k,%n)) {
    %n = $readn
    %mw = $gettok($ifmatch,2,61) | %mwt = %mw | var %r = 1
    %n2 = 1
    while ((%n2 <= %n1) && %mwt) {
      if ($pos(%mwt,$mid($1,%n2,1))) {
        %p = $ifmatch
        %mwt2 = $right(%mwt,- $+ %p) | dec %p | %mwt1 = $left(%mwt,%p)
        %mwt = %mwt1 $+ %mwt2
        inc %r
      }
      inc %n2
    }
    dec %n2
    if ($calc( %n1 - %n2 )) { dec %r $ifmatch }
    if ($len(%mwt)) { dec %r $ifmatch }
    if (!%rl) { %rl = %r }
    if (%rl < %r) { var %mws }
    if (%rl <= %r) { %mws = $addtok(%mws,%mw,149)  | %rl = %r }
    inc %n
  }
  if (!%mws) { %mws = NoMatch | did -a S.dialog 14 $1 | did -t S.dialog 9 }
  if ((%mws) && (%mws != NoMatch)) {
    var %t = $numtok(%mws,149)
    var %n = 1
    while (%n <= %t) {
      did -a S.dialog 8 $gettok(%mws,%n,149)
      inc %n
    }
    did -a S.dialog 14 $did(S.dialog,8,1).text
  }
}

alias S.return {
  if ($dialog(S.dialog)) { dialog -k S.dialog S.dialog | .timer -m 1 200 S.return $1- | return }
  if ($1 == -S) { inc %SC.n 1000 | S.check.1 | return }
  elseif ($1 == -I) { goto end }
  elseif ($1 == -A) { S.add $2 | w.cd $2 }
  elseif ($1 == -C) { set %SC.txt $puttok(%SC.txt,$replace($gettok(%SC.txt,%SC.n,32),%SC.w,$2-),%SC.n,32) }
  elseif ($1 == -L) { set %SC.txt $replace(%SC.txt,%SC.w,$2-) }
  else { echo -a weeeeee! }
  :end
  inc %SC.n | S.check.1
}

alias -l S.add {
  var %w = $remove($1-,')
  if (%w !isalpha) { echo -a letters and <'> only please | return }
  var %c = $S.code(-s,%w)
  var %k = %c $+ $chr(61) $+ $1
  var %f = $scriptdir $+ Dictionary\ $+ Dictionary- $+ $left(%c,1) $+ .txt
  %a = $read(%f,wn,%k,1)
  if (!$readn) { write -il1 %f %k }
}

alias -l S.rem {
  var %c = $S.code(-s,$1)
  var %k = %c $+ $chr(61) $+ $1
  var %f = $scriptdir $+ Dictionary\ $+ Dictionary- $+ $left(%c,1) $+ .txt
  %a = $read(%f,wn,%k,1)
  if ($readn) { write -d [ $+ [ $readn ] ] %f }
}

alias S.code {
  ;<trm>
  var %trm = $2
  var %n1 = 1
  ;;---- Refined Soundex Algorithm ----
  var %Sex = $left(%trm,1) $+ $replace($remove($left(%trm,-1),a,e,i,o,u,h,w,y),b,1,p,1,f,2,v,2,c,3,k,3,s,3,g,4,j,4,q,5,x,5,z,5,d,6,t,6,l,7,m,8,n,8,r,9)
  if ($1 == -s) { while ($replace(%Sex,11,1,22,2,33,3,44,4,55,5,66,6,77,7,88,8,99,9) != %Sex) { %Sex = $ifmatch } }
  ;;-----------------------------------
  if ($isid) { return %Sex }
  else { echo -a The Soundex code for $1 is: %Sex  }
}

dialog S.dialog {
  title "Spell Checker"
  size -1 -1 112 84
  option dbu
  button "&Change", 6, 72 42 37 12
  button "Change A&ll", 7, 72 56 37 12
  button "Add to Dict", 9, 72 26 37 12
  button "&Ignore", 10, 72 12 37 12
  text "", 11, 22 3 85 8
  button "Stop Checking", 12, 4 70 39 12
  button "ok", 13, 92 72 17 10, hide ok
  list 8, 2 24 68 44, size vsbar
  edit "", 14, 2 12 68 10, autohs
  box "", 15, 19 0 88 11
  text "Word:", 16, 4 3 15 8
}

on *:dialog:S.dialog:init:0:{ did -t $dname 12 }

on *:dialog:S.dialog:sclick:*:{
  if ($did == 8) { set %SC.nw $did($dname,8).seltext | did -r $dname 14 | did -a $dname 14 %SC.nw }
  elseif ($did == 12) { S.return -S }
  elseif ($did == 10) { S.return -I }
  elseif ($did == 9) { S.return -A $did($dname,11) }
  elseif ($did == 6) { S.return -C $did($dname,14) }
  elseif ($did == 7) { S.return -L $did($dname,14) }
}

dialog S.CDict {
  title "Custom Dictionary"
  size -1 -1 112 84
  option dbu
  list 1, 2 14 66 68, sort size
  edit "", 2, 2 2 66 10
  button "Add Word", 3, 70 2 39 12
  button "Rem Word", 4, 70 16 39 12
  button "Ok", 5, 72 70 35 12, ok
}

on *:dialog:S.CDict:init:0:{
  var %n = 1
  while ($r.cdn(%n)) {
    did -a $dname 1 $ifmatch
    inc %n
  }
}

on *:dialog:S.CDict:sclick:*:{
  if ($did == 3) { if (!$w.cd($did($dname,2))) { S.add $did($dname,2) | did -a $dname 1 $did($dname,2) | did -r $dname 2 } }
  elseif ($did == 1) { did -r $dname 2 | did -a $dname 2 $did($dname,1).seltext }
  elseif ($did == 4) {
    if (!$d.cd($did($dname,2))) {
      S.rem $did($dname,2)
      did -r $dname 1
      var %n = 1
      while ($r.cdn(%n)) {
        did -a $dname 1 $ifmatch
        inc %n
      }
      did -r $dname 2
    }
  }
}

on *:dialog:S.CDict:edit:*:{ did -t $dname 3 }

;dialog S.settings {
;  title "Spell Checker Settings"
;  size -1 -1 96 46
;  option dbu
;  check "Enable SpellCheck in channels", 1, 4 6 88 10
;  check "Enable SpellCheck in queries", 2, 4 18 88 10
;  box "", 3, 2 2 92 28
;  button "OK", 4, 32 32 29 12, ok
;}
;
;
;on *:dialog:S.settings:init:0:{
;  if ($r.set(settings,SCC)) { did -c $dname 1 }
;  if ($r.set(settings,SCQ)) { did -c $dname 2 }
;}
;
;on *:dialog:S.settings:sclick:*:{
;  if ($did == 1) { if ($did($dname,1).state) { w.set settings SCC 1 } | else { w.set settings SCC 0 } }
;  if ($did == 2) { if ($did($dname,2).state) { w.set settings SCQ 1 } | else { w.set settings SCQ 0 } }
;}
